/* Experiment with the Lorentz contraction. */
/* The code containes to add ``9s'', i.e. the */
/* ratio of velocity to speed of light goes as */
/* 0.9, 0.99, 0.999, 0.9999 and so on .... */
#include <math.h>
#include <stdio.h>
int main()
{
  int i,	/* counter for each contraction */
      n;	/* how many contractions */
  double x,		/* multiplicative factor */
         ratio,		/* statu's velocity divided by speed of light */
         timeslow,	/* time-slowing factor */
         length,	/* initial length of statue of liberty */
         newlength;	/* length of statue after contraction */

  n = 10;	/* compute 10 values */
  length = 46.;	/* length of the Statue of Liverty in meters */

  printf("      v/c  time-slowing factor  length of the statue\n");
  for(x = 1.0, ratio = 0.0, i = 0; i < n; i++, x *= 0.1) {
    ratio += 0.9 * x;
    timeslow = 1/(sqrt(1-ratio*ratio));
    newlength = length/timeslow;
    printf("%12.10f\t%12.6f\t%10.7f\n", ratio, timeslow, newlength);
  }

  return(0);
}
