/* Create quantum foam diagrams */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define SIZE 128
void show_cells(short c[SIZE][SIZE], int size);
int main()
{
  float r;	/* random number, 0-1 */
  short c[SIZE][SIZE];	/* arrays for holding 1 and 0 values */
  short ch[SIZE][SIZE];
  int size, time_steps, steps, i, j, sum;

  size = 80;	/* use larger sizes for nicer images */
  time_steps = 20;	/* controle how many steps foam is to evolve */
  /* initially seed space with random 0's and 1's */
  for(i = 0; i <= size; i++) 
    for(j = 0; j <= size; j++) {
      r = (float)rand()/RAND_MAX;
      if (r >= .5) c[i][j] = 0;
      if (r <= .5) c[i][j] = 1;
    }
  show_cells(c, size);

  /* perform simulation based on twisted majority rules 
     to form foamlike objects in 2-D */
  for(steps = 1; steps < time_steps; steps++) {
    for(i = 1; i < size; i++) {
      for(j = 1; j < size; j++) {
	/* compute sum of neighbor cells */
	sum = c[i+1][j+1] + c[i][j+1] + c[i-1][j+1] + 
	      c[i+1][j]   + c[i][j]   + c[i-1][j]   + 
	      c[i+1][j-1] + c[i][j-1] + c[i-1][j-1]; 
	if (sum == 9) ch[i][j] = 1;
	if (sum == 8) ch[i][j] = 1;
	if (sum == 7) ch[i][j] = 1;
	if (sum == 6) ch[i][j] = 1;
	/* notice ``twist'' in rules which destabilizes blob boundaries */
	if (sum == 5) ch[i][j] = 0;
	if (sum == 4) ch[i][j] = 1;
	if (sum == 3) ch[i][j] = 0;
	if (sum == 2) ch[i][j] = 0;
	if (sum == 1) ch[i][j] = 0;
	if (sum == 0) ch[i][j] = 0;
      }
    }
    for(i = 0; i <= size; i++) 
      for(j = 0; j <= size; j++) 
	c[i][j] = ch[i][j];
  }

  printf("A plot of last frame of simulation\n");
  show_cells(c, size);

  return(0);
}

void show_cells(short c[SIZE][SIZE], int size)
{
  int i, j;

  /* If you like, you can make a movie of all frames 
     to show foam evolving. */
  for(i = 0; i <= size; i++) {
    for(j = 0; j <= size; j++) {
      /* crude attempt to draw blobs using characters */
      /* better to use hi-res graphics package */
      if (c[i][j] == 1) printf("*"); 
      else printf(" ");
    }
    printf("\n");
  }

  return;
}
